<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
        PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
        "http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.pnkx.mapper.PxNoteFolderMapper">

    <resultMap type="PxNoteFolder" id="PxNoteFolderResult">
        <result property="id" column="id"/>
        <result property="name" column="name"/>
        <result property="parentId" column="parent_id"/>
        <result property="password" column="password"/>
        <result property="order" column="order"/>
        <result property="delFlag" column="del_flag"/>
        <result property="version" column="version"/>
        <result property="createBy" column="create_by"/>
        <result property="createTime" column="create_time"/>
        <result property="updateBy" column="update_by"/>
        <result property="updateTime" column="update_time"/>
        <result property="remark" column="remark"/>
    </resultMap>

    <sql id="selectPxNoteFolderVo">
        select id,
               name,
               parent_id,
               password,
               `order`,
               del_flag,
               version,
               create_by,
               create_time,
               update_by,
               update_time,
               remark
        from px_note_folder
    </sql>

    <select id="selectPxNoteFolderList" parameterType="PxNoteFolder" resultMap="PxNoteFolderResult">
        <include refid="selectPxNoteFolderVo"/>
        <where>
            del_flag = 0
            <if test="name != null  and name != ''">
                and name like concat('%', #{name}, '%')
            </if>
            <if test="parentId != null ">
                and parent_id = #{parentId}
            </if>
            <if test="password != null  and password != ''">
                and password = #{password}
            </if>
            <if test="version != null  and version != ''">
                and version = #{version}
            </if>
        </where>
        ORDER BY isnull(`order`) || `order`='' ,`order`,
        update_time DESC
    </select>

    <select id="selectPxNoteFolderById" parameterType="Long"
            resultMap="PxNoteFolderResult">
        <include refid="selectPxNoteFolderVo"/>
        where id = #{id}
    </select>

    <insert id="insertPxNoteFolder" parameterType="PxNoteFolder" useGeneratedKeys="true"
            keyProperty="id">
        insert into px_note_folder
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="name != null">name,
            </if>
            <if test="parentId != null">parent_id,
            </if>
            <if test="password != null">password,
            </if>
            <if test="order != null">`order`,
            </if>
            <if test="delFlag != null">del_flag,
            </if>
            <if test="version != null">version,
            </if>
            <if test="createBy != null">create_by,
            </if>
            <if test="createTime != null">create_time,
            </if>
            <if test="updateBy != null">update_by,
            </if>
            <if test="updateTime != null">update_time,
            </if>
            <if test="remark != null">remark,
            </if>
        </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="name != null">#{name},
            </if>
            <if test="parentId != null">#{parentId},
            </if>
            <if test="password != null">#{password},
            </if>
            <if test="order != null">#{order},
            </if>
            <if test="delFlag != null">#{delFlag},
            </if>
            <if test="version != null">#{version},
            </if>
            <if test="createBy != null">#{createBy},
            </if>
            <if test="createTime != null">#{createTime},
            </if>
            <if test="updateBy != null">#{updateBy},
            </if>
            <if test="updateTime != null">#{updateTime},
            </if>
            <if test="remark != null">#{remark},
            </if>
        </trim>
    </insert>

    <update id="updatePxNoteFolder" parameterType="PxNoteFolder">
        update px_note_folder
        <trim prefix="SET" suffixOverrides=",">
            <if test="name != null">name =
                #{name},
            </if>
            <if test="parentId != null">parent_id =
                #{parentId},
            </if>
            <if test="password != null">password =
                #{password},
            </if>
            <if test="order != null">`order` =
                #{order},
            </if><if test="delFlag != null">del_flag =
                #{delFlag},
            </if>
            <if test="version != null">version =
                #{version},
            </if>
            <if test="createBy != null">create_by =
                #{createBy},
            </if>
            <if test="createTime != null">create_time =
                #{createTime},
            </if>
            <if test="updateBy != null">update_by =
                #{updateBy},
            </if>
            <if test="updateTime != null">update_time =
                #{updateTime},
            </if>
            <if test="remark != null">remark =
                #{remark},
            </if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deletePxNoteFolderById" parameterType="Long">
        update px_note_folder
        set del_flag = 1
        where id = #{id}
    </delete>

    <delete id="deletePxNoteFolderByIds" parameterType="String">
        update px_note_folder set del_flag = 1 where id in
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>
</mapper>
